#!/usr/bin/env ruby
require 'modules/htmlentities'

htmlentities = HTMLEntities.new
sta=`wlanconfig ath0 list sta`

arp_cache=File.open("/proc/net/arp").read
log_cache=File.open("/tmp/status.log").read.split("\n").reverse.join("\n")

data=[]
sta.each_line{|l|
	if (matches = /^([0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2})/.match(l)):
		values = {
			"mac_address" => matches[1],
			"ip"=>"",
			"time"=>"",
			"ssid"=>""
			}

		if (arp_matches = /^([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}).*#{values["mac_address"]}/i.match(arp_cache)):
			values["ip"]=arp_matches[1]
		end 

		if (ssid_matches = /(.*): Node \[#{values["mac_address"]}\] associating to ssid \["(.*)"\]/s.match(log_cache)):
			values["ssid"]=ssid_matches[2]
			values["time"]=ssid_matches[1]
		end
		data << values
	end
}

print <<EOF
<table summary='details of connected clients'>
	<thead>
		<tr>
			<th style='width: 150px'>Date</th>
			<th style='width: 200px'>SSID</th>
			<th style='width: 100px'>IP</th>
			<th style='width: 100px'>MAC</th>
			<th style='width: 150px'>Commands</th>
		</tr>
	</thead>
	<tbody>
EOF
if (data.length > 0):
	if(File.exists?("/tmp/script_option_list"))
		script_options=File.new("/tmp/script_option_list").read
	else
		script_options=""
	end	
	data.each{|l|
		print <<EOF
		<tr>
			<td>#{htmlentities.encode(l["time"])}</td>
			<td>#{htmlentities.encode(l["ssid"])}</td>
			<td>#{htmlentities.encode(l["ip"])}</td>
			<td>#{htmlentities.encode(l["mac_address"])}</td>
			<td>
				<form method='post' action='/cgi-bin/status.rb'>
					<p>
						<select name='command'>
							<option value='add_ssid'>Add to SSID list</option>
							<option value='kick_mac'>Kick MAC</option>
							#{script_options}
						</select>
						<input onclick="return (exec_command(this))" type="submit" value="Excute" name="submit" />
						<input type='hidden' name='ssid' value='#{htmlentities.encode(l["ssid"])}' />
						<input type='hidden' name='ip' value='#{htmlentities.encode(l["ip"])}' />
						<input type='hidden' name='mac' value='#{htmlentities.encode(l["mac_address"])}' />
					</p>
				</form>
			</td>
		</tr>
EOF
	}
else
	print <<EOF
	<tr>
		<td colspan="5">No Data</td>
	</tr>
EOF
end
puts <<EOF
	</tbody>
</table>
EOF
